<?php

/**
 * @file
 * API hooks for the TACJS module.
 */

/**
 * Implements hook_tacjs_content_alter().
 */
function hook_tacjs_content_alter(array &$content) {
  $content['analytic']['my_custom_analytic_service'] = [
    "about" => [
      "name" => "My Custom Analytic Service",
    ],
    // Generates warnings in logs if omitted.
    "code" => [
      "js" => "",
      "html" => "",
    ],
  ];
}

/**
 * Implements hook_tacjs_services_alter().
 */
function hook_tacjs_services_alter(array &$services) {
  // Path to the module JavaScript file containing my custom services.
  $tacjs_path = \Drupal::service('extension.list.module')->getPath('my_module');
  $inputFile = $tacjs_path . '/js/my_custom_services.js';

  $jsContent = file_get_contents($inputFile);

  $pattern = '/tarteaucitron\.services\.(\w+)\s*=\s*\{\s*\n?([\s\S]*?)\n\};/m';
  preg_match_all($pattern, $jsContent, $matches, PREG_SET_ORDER);

  foreach ($matches as $match) {
    $serviceName = $match[1];
    $services[$serviceName] =
      "tarteaucitron.services." . $serviceName . " = {\n" . $match[2] . "\n};";
  }
}
